#!/usr/bin/env python
from subprocess import call
import os
import sys
import re
import fileinput


version = None
versionn = None


def get_setup_py_lines():
    global version
    global versionn
    with open('setup.cfg', 'r') as sf:
        current_setup = sf.readlines()
        for line in current_setup:
            if line.startswith('version = '):
                release, major, minor, correct = re.findall(r"version = (\w+)-(\d+)\.(\d+)\.(\d+)", line)[0]
                version = "{}-{}.{}.{}".format(release,major, minor, int(correct)+ 1)
                versionn = "{}.{}.{}".format(major, minor, int(correct)+ 1)
                yield "version = {}\n".format(version)
                print('new versions is %s' % version)
            else:
                yield line

lines = list(get_setup_py_lines())
with open('setup.cfg', 'w') as sf:
    sf.writelines(lines)

for lin in fileinput.input(['src/lmgbuild/lmgbuild.py'], inplace=True,backup='.bak'):
    if lin.startswith('VERSION ='):
        sys.stdout.write('VERSION = "%s"\n' % versionn)
    else:
        sys.stdout.write(lin)

#call('rm -f dist/*', shell=True)
call('python3 setup.py sdist',shell=True)
call('pyinstaller lmgbuild.spec -F',shell=True)
call('pyinstaller export_source.spec -F',shell=True)
call('staticx dist/lmgbuild dist/lmgbuild' + "-" + version,shell=True)
call('staticx dist/export_source dist/export_source' + "-" + version,shell=True)
call('chmod 755 dist/lmgbuild',shell=True)
call('chmod 755 dist/export_source',shell=True)
call('chmod 755 dist/lmgbuild' + "-" + version,shell=True)
call('chmod 755 dist/export_source' + "-" + version,shell=True)

#call('git pull', shell=True)
#call('git commit -am "Bump to {}"'.format(version), shell=True)
#call('git tag {}'.format(version), shell=True)
#call('git push', shell=True)
#call('git push --tags', shell=True)
#
#env = os.environ
#env['CONVERT_README'] = 'true'
#call('rm -rf dist/*', shell=True, env=env)
#call('python setup.py sdist bdist_wheel', shell=True, env=env)
#call('twine upload dist/*', shell=True, env=env)
