import sys
import subprocess
from setuptools import __version__, setup
from setuptools.command.install import install

if int(__version__.split(".")[0]) < 40:
    raise RuntimeError("setuptools >= 40 required to build")
class pre_set(install):
     def run(self):
         cmd = ['python3', 'src/lmgbuild/confset.py']
         if subprocess.call(cmd) != 0:
             sys.exit(1)
         setuptools.command.install.install.run(self)

#VERSION = '1.0.8'

setup(
    packages=['lmgbuild'],
    package_data={'lmgbuild':['*.yaml','template/*.yaml','conf/*.yaml']},
#    use_scm_version={
#        "root": "..",
#        "relative_to": __file__,
#    },
    #data_files=[('lmgbuild/etc/conf', ['lmgbuild/conf/*.yaml']),('lmgbuild/etc/template',['lmgbuild/template/*.yaml'])],
    data_files=[('lmgbuild/etc/conf', ["src/lmgbuild/conf/default-base.yaml","src/lmgbuild/conf/local-base.yaml","src/lmgbuild/conf/repository-base.yaml","src/lmgbuild/conf/config.yaml"]), 
                ('lmgbuild/etc/template', ["src/lmgbuild/template/cache.yaml"]),
                ('lmgbuild/bin/', ["src/lmgbuild/export_normal.sh"]),
                ],
    
    setup_requires=["setuptools_scm >= 2"],
#    cmdclass={
#        "install": pre_set,
#    }
)
