#!/bin/bash

# $1 debname
ICONPATH=""
DESKTOPPATHES=""
sufixs="png svg xpm"


# $1 desktopfile
function get_desktop_icon(){
    OLD_IFS=$IFS
    IFS=' '
    iconname=$(cat $1 |grep '^Icon=' |awk -F'=' '{print $2}' | sed "s/\r//g")

    if [ -f $iconname ];then
        echo $iconname
        return
    fi
    for sufix in $sufixs
    do
        echo $iconname |grep \\.$sufix 2>&1 1>/dev/null
        ret=$?
        if [ $ret -ne 0 ];then
            iconnames="$iconnames $iconname.$sufix"
        else
            iconnames="$iconnames $iconname"
        fi
    done

    for icon in $iconnames
    do
        iconpathes="$iconpathes "$(find /usr/share/icons/hicolor |grep $icon|| dpkg -L $debname |grep $icon)""
    done

    if [ -z $iconpathes ];then
	    for icon in $iconnames
	    do
       		 iconpathes="$iconpathes "$(find /usr/share/icons/ |grep $icon|| dpkg -L $debname |grep $icon)""
	    done
    fi
    # /usr/share/icons/hicolor/
    # png svg xpm

#    iconpathes=$(find /usr/share/icons/hicolor |grep $iconname.png || dpkg -L $debname |grep $iconname.png)
#    if [ -z "$iconpathes" ] ;then
#        iconpathes=$(find /usr/share/icons/hicolor |grep $iconname.svg || dpkg -L $debname |grep $iconname.svg)
#        if [ -z "$iconpathes" ] ;then
#            iconpathes=$(find /usr/share/icons/hicolor |grep $iconname.xpm || dpkg -L $debname |grep $iconname.xpm)
#        fi
#    fi
#
    # size default 48*48
    # 48x48 24x24 22x22


    iconpath=$(echo $iconpathes |grep '48x48')
    if [ -z "$iconpath" ];then
        iconpath=$(echo $iconpathes |grep '24x24')
        if [ -z "$iconpath" ];then
            iconpath=$(echo $iconpathes |grep '22x22')
        fi
    fi

    IFS=$OLD_IFS

    # default size can't find
    if [ -z "$iconpath" ];then
        iconpath=$(echo $iconpathes |awk '{print $1}')
    else
	iconpath=$(echo $iconpath |awk '{print $1}')

    fi

    if [  -z "$iconpath" ];then
        echo "no iconfile"
        exit 0
    else
        echo $iconpath
    fi
}

# get dekstop $1 debname
function get_deb_desktop(){
    desktopfiles=$(dpkg -L $1 |grep .*applications/.*desktop$)
    if [ -z "$desktopfiles" ];then
        echo "no desktopfile"
        exit 0
    else
        DESKTOPPATHES=$desktopfiles
    fi
}

# deb
get_normal_files()
{
    if [ ! -z $1 ] && [ ! -z $2 ];then
        get_deb_desktop $1
    debname=$1
	destdir=$2
    else
        echo "arguments error"
    fi
    if [ -z "$DESKTOPPATHES" ];then
        echo "no desktopfiles"
    else
	    for file in `echo $DESKTOPPATHES`
	    do
		    cp $file $destdir/Data/AppData/
		    iconpath=$(get_desktop_icon $file $debname)
		    cp $iconpath $destdir/Data/AppData/
	    done
    fi
}
clean_buildenv()
{
    rm -f /tmp/*.deb
    rm $0
}


#icon_from_desktop /usr/share/applications/wps-office-et.desktop
#icon_from_desktop /usr/share/applications/wps-office-pdf.desktop
get_normal_files $1 $2
clean_buildenv
