import xdg
from xdg.IconTheme import *
import lmgbuild.lmgutil as utl
import lmgbuild.lmgexceptions
#from xdg.IconTheme import IconTheme
from xdg.DesktopEntry import DesktopEntry
import argparse
import os
import shutil
#deb package
AUTOSTART_DESKTOP = set()
APPLICATION_DESKTOP = set()
NOTUSED_DESKTOP = set()
ICON_PATH = set()
APPDATA_DIR = "Data/AppData/"
AUTOSTART_DIR = "Data/AppData/autostart/"
def get_desktop_from_deb_package(debname):
    cmd = ["dpkg","-L",debname]
    ret = utl.runshell(cmd)
#    if ret != 0 :
#        raise ExportSourceError(cmd)
    filestr = ret.stdout
    desklist = []
    for f in filestr.split("\n"):
        if os.path.isfile(f):
            if f.endswith(".desktop"):
                desklist.append(f)
    return desklist
def get_system_by_desktop(desklist):
    newdesklist = []
    for f in desklist:
        if os.path.dirname(f) in ['/usr/share/applications','/usr/local/share/applications'] :
            APPLICATION_DESKTOP.add(f)
        elif os.path.dirname(f) in ['/etc/xdg/autostart'] :
            AUTOSTART_DESKTOP.add(f)
        else:
            """find system dir desktop"""
            desktopname = os.path.basename(f)
            systemdesk = os.path.join('/usr/share/applications/',desktopname)
            systemldesk = os.path.join('/usr/local/share/applications',desktopname)
            if os.path.isfile(systemdesk) :
                APPLICATION_DESKTOP.add(systemdesk)
            elif os.path.isfile(systemldesk) :
                APPLICATION_DESKTOP.add(systemldesk)
            else :
                NOTUSED_DESKTOP.add(f)
    return APPLICATION_DESKTOP
def get_deb_normal_file_list(deskname):
    entry = DesktopEntry(deskname)
    iconname = entry.getIcon()
    iconpath = getIconPath(iconname)
    ICON_PATH.add(iconpath)
def clean_buildenv(filename):
    os.remove(filename)
#print(xdg.BaseDirectory.xdg_config_home)
#print(xdg.BaseDirectory.xdg_config_dirs)
#print(xdg.BaseDirectory.xdg_data_dirs)
##get_deb_normal_file_list("atril")
if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument("debname",nargs='*',help="package name")
    parser.add_argument("-a","--applications",action='store_true',default=False,help="applications desktop")
    parser.add_argument("-s","--autostart",action='store_true',help="autostart desktop")
    parser.add_argument("-n","--notused",action='store_true',help="not used desktop")
    parser.add_argument("-i","--icon",action='store_true',help="icon")
    parser.add_argument("-d","--destdir",dest='destdir',help="source destdir")
    args =parser.parse_args()
    if args.debname:
        desklist=get_desktop_from_deb_package(args.debname[0])
        get_system_by_desktop(desklist)
        # jd-gui /opt/xxx.desktop
        if not APPLICATION_DESKTOP:
            APPLICATION_DESKTOP = NOTUSED_DESKTOP
        for f in APPLICATION_DESKTOP:
            get_deb_normal_file_list(f)
        if args.debname[1]:
            destdir=args.debname[1]
            for f in APPLICATION_DESKTOP:
                if f:
                    shutil.copy(f,os.path.join(destdir,APPDATA_DIR))
            for f in ICON_PATH:
                if f:
                    shutil.copy(f,os.path.join(destdir,APPDATA_DIR))
            for f in AUTOSTART_DESKTOP:
                if f:
                    shutil.copy(f,os.path.join(destdir,AUTOSTART_DIR))
    if args.autostart:
        print(AUTOSTART_DESKTOP)
    elif args.applications:
        print(APPLICATION_DESKTOP)
    elif args.notused:
        print(NOTUSED_DESKTOP)
    elif args.icon:
        print(ICON_PATH)

    """clean_buildenv"""



