#!/bin/python3
#-*- coding: utf-8 -*-
import os
import platform
import time


from collections import namedtuple
import yaml
import shutil
import re
from lmgbuild.lmgpreseter import *
#from lmgbuild.lmgutil import LMGUtil as utl
import lmgbuild.lmgutil as utl
from lmgbuild.lmgexceptions import *
from lmgbuild.argument_parser import Parser
from lmgbuild.lmgmeta import LMGMeta
from lmgbuild.lmgcreater import LMGCreater
import lmgbuild.logs as logs
from multiprocessing import Process,Queue
from alive_progress import alive_bar
from lmgbuild.conf import settings
#default , -c presetconfig , -f pkgfile, -l pkglist

# 预设部分封装成一个类共有部分
# app，base考虑继承预设部分的内容，增加自己独有成员
VERSION = "1.1.29"

Preset = namedtuple('Preset','lmg_type lmg_output_dir lmg_workdir arch lmg_release lmg_base')
def check_dir(directorys):
    for directory in directorys:
        ok = os.path.isdir(directory)
        if ok:
            ok = os.access(directory, os.X_OK | os.W_OK)
            if not ok:
                raise DirectoryError("Permission denied for directory")
        else:
            raise DirectoryError("directory is not exists")
def preset_by_config(configpath):
    # description,目前无法配置，待完善
#    preseter=LMGPreseter()
    with open(configpath,'r') as file:
        config = yaml.safe_load(file)
        check_dir([config['lmg_output_dir'],config['lmg_workdir']])
        preset = Preset(config['lmg_type'],config['lmg_output_dir'],config['lmg_workdir'],config['arch'],config['lmg_release'],config['lmg_base'])
        pkglist = config['pkglist']
        return preset,pkglist
#def preset_by_inter():
#    preseter=LMGPreseter()
#    lmg_type,lmg_output_dir,lmg_workdir=preseter.init_preset()
#    if lmg_type == "BASERUNTIME":
#        arch,pkgpath,description=preseter.base_preset()
#        lmg_base = ""
#        lmg_release=""
#        deppath=""
#    elif lmg_type is "APPLICATIONS":
#        # 增加依赖软件包
#        arch,lmg_release,lmg_base,pkgpath,deppath = preseter.app_preset()
#        description = yaml.safe_load(utl.runshell(["dpkg-deb","-f",pkgpath]).stdout)['Description']
#    preset=Preset(lmg_type,lmg_output_dir,lmg_workdir,arch,lmg_release,lmg_base)
#    return preset,pkgpath,description,deppath

# 读取pkglist,defaut

# args : presetconfig pkgpath description
def lmg_build(preset,pkgpath,description=None,deppath=None,msgque=None):
    # 1 creater init

    try:
        creater = LMGCreater(lmg_type=preset.lmg_type,lmg_release=preset.lmg_release,lmg_output_dir=preset.lmg_output_dir,lmg_base=preset.lmg_base,lmg_workdir=preset.lmg_workdir,arch=preset.arch,deppath=deppath,msgque=msgque)

    # 2 base set

#    msgque.put("0")
        creater.set_lmg_name_by_pkg(pkgpath)
    # 3 pkgtype
#    msgque.put("1")
        creater.set_pkgtype(pkgpath)
    # 4 create dir
#    msgque.put("2")
        creater.create_lmg_basedir()
        # 5 gen baseinfo
        creater.generate_baseinfo(pkgpath)
        # 6 gen meta
        creater.generate_meta(description)
        # 7 checkdependence
        creater.checkdependence()
        # 8 gen data
#        msgque.put("1")
        creater.generate_data(pkgpath)
#        msgque.put("2")
        # 9 gen checksum
        creater.generate_checksum()
#        msgque.put("3")
        # 10 gen lmg
#        logs.message("Please wait for compressing...")
        creater.generate_lmg()
#        msgque.put("4")
#        logs.message("Complete building,Please wait for cleanning !!!")
    except Exception as e:
        logs.exception("build error %s" % creater.lmg_name,sys.exc_info())
    finally:
        # 11 clean
        creater.clean_environ()
 #       msgque.put("end")
#        logs.message("Complete Cleanning !!!")
#def check_base_tar(filename):
#    if re.match('.*(?=brl.tar$)',filename):
#        return 0
#    else:
#        return -1
#def import_baseruntime(baseruntime):
#    if not os.path.exists(baseruntime):
#        raise BaseRuntimeError(baseruntime + " is not a file")
#    preseter=FactoryPreseter()
#    if check_base_tar(baseruntime):
#        raise BaseRuntimeError("this file is not a baseruntime package")
#    imagename = os.path.basename(baseruntime).replace("_brl.tar",":brl")
#    cmd = ["docker","inspect",imagename]
#    ret=utl.runshell(cmd)
#    if ret.returncode:
#        print("install baseruntime,please wait ......\n")
#        cmd = ['docker','load','-i',baseruntime]
#        ret=utl.runshellbar(cmd)
#        if ret.returncode != 0:
#            raise ImageLoadError("%s load failed" % baseruntime)
#        else:
#            print("install baseruntime ok")
#    else:
#        print("baseruntime already installed")
#    # 增加工作目录的配置文件，比如隐藏文件，读取环境变量,增加环境变量指定目录
#    with open(preseter.lmghome + "/" + "conf/local-base.yaml","r+") as f:
#        stream = yaml.safe_load(f)
#        if stream is None:
#            stream = {}
#        f.seek(0)
#        item=os.path.basename(baseruntime).replace("_brl.tar","")
#        arch = platform.machine()
#        if arch == "loongarch64":
#            arch = "loong64"
#        if item not in stream.setdefault(arch,[]):
#            stream[arch].append(item)
#            yaml.dump(stream,f,allow_unicode=True)
def lmgbuildstart():
    settings.init()
    msgque = Queue()
    parser = Parser()
    args = parser.parse(sys.argv)
    if args.config:
        preset,pkglist = preset_by_config(args.config)
        #auto install,lmg_base 5,arch 3
        utl.sync_repository(tryexec=True)
        utl.auto_installbase(preset[5],preset[3])
        for pkgdict in pkglist:
            try:
#                description = yaml.safe_load(utl.runshell(["dpkg-deb","-f",pkgdict['pkgpath']]).stdout)['Description']
                description = "lmg app"
                pkgdict.setdefault('deppath',[])
                p1 = Process(target=lmg_build,args=(preset,pkgdict['pkgpath'],description,pkgdict['deppath'],msgque))
                p1.start()
                title = os.path.basename(pkgdict['pkgpath']).split("_")[0] + ":"
#                with alive_bar(13,title=title,disable=True) as bar:
# if debug , disable , processbar
                with alive_bar(13,title=title) as bar:
                    for i in range(13):
                        msg=msgque.get()
                        time.sleep(0.5)
                        bar()
                        bar.text(msg)
                        logs.debug(msg)
                        if msg == "end":
                            break
                p1.join()
                #lmg_build(preset,pkgdict['pkgpath'],description,pkgdict['deppath'])
            except Exception as e:
                logs.exception("%s build failed" % pkgdict['pkgpath'],sys.exc_info())
                continue
    elif args.help:
        parser.print_help()

        #		if args.arch is None:
        #			raise argparse.ArgumentError("the arch must be set, user -a option")
        #		else:
    elif args.workdir:
        utl.generate_conf(os.path.abspath(args.workdir))
        utl.generate_cache(args.workdir)
    elif args.version:
        sys.stderr.write("version:%s\n" % VERSION)
    elif args.sync:
        utl.sync_repository(tryexec=False)
    elif 'showruntime' in args and args.showruntime:
        utl.showruntime()
    elif 'showorkspace' in args and args.showorkspace:
        utl.showorkspace()
    elif 'druntime' in args and args.druntime:
        utl.deleteruntime(args.druntime)
    elif 'lruntime' in args and args.lruntime:
        utl.import_baseruntime(args.lruntime)
    else:
        preset,pkgpath,description,deppath = FactoryPreseter().product_preseter().preset()
        p2 = Process(target=lmg_build,args=(preset,pkgpath,description,deppath,msgque))
        p2.start()
        title = os.path.basename(pkgpath).split("_")[0] + ":"
        with alive_bar(13,title=title) as bar:
            for i in range(13):
                msg=msgque.get()
                time.sleep(0.5)
                bar()
                bar.text(msg)
                logs.debug(msg)
                if msg == "end":
                    break
        p2.join()
#        lmg_build(preset,pkgpath,description,deppath)
        #lmg_build(preset)
        #print(preset_by_config("config.yaml"))
if __name__ == '__main__':
    FactoryPreseter()
    lmgbuildstart()










