import sys
import hashlib
import os

DEBUG=0

class LMGChecksum(object):
    def __init__(self,blocksize=65536):
        self.blocksize = blocksize
    """lmg checksum class"""
    def GetFilesList(self,input_path_name):
        ''' get file list '''
        result = list()
        for dirpath, dirnames, filenames in os.walk(input_path_name, followlinks=True):
            for filename in filenames:
                file_path = os.path.join(dirpath, filename)
                result.append(file_path)
                result.sort()
        return result
    def CalcFileSha256(self,filname):
        ''' calculate file sha256 '''
        sha256obj = hashlib.sha256()
        with open(filname, "rb") as f:
            file_buffer = f.read(self.blocksize)
            while len(file_buffer) > 0:
                sha256obj.update(file_buffer)
                file_buffer = f.read(self.blocksize)
            hash_value = sha256obj.hexdigest()
            return hash_value
    def GetFileContent(self,input_path_name):
        ''' get file contnet '''
        files_list = self.GetFilesList(input_path_name)
        result = list()
        for f in files_list:
            hash = self.CalcFileSha256(f)
            f=f.replace(input_path_name + "/","")
            dictionary = {f : hash}
            result.append(dictionary)
        return result
    def WriteToFile(self,contents,filename):
        ''' write content to the specified file '''
        fp = open(filename, "w")
        for content in contents:
            #print("content:", content)
            str0 = str(content)
            str1 = str0.replace("\\\\", "/")
            if DEBUG:
               print(str1)
            fp.write(str1)
            fp.write("\n")
        fp.close()

if __name__ == "__main__":
    print("lmg checksum class")
    a=LMGChecksum()
    filect=a.GetFileContent("/home/loongson/lmg/vlc-3.0.11-3-deb10u1.lnd.1.1.app/")
    a.WriteToFile(filect,"./testfilesha")



