#!/usr/bin/python3
import yaml
import os
class LMGMeta(object):
    def __init__(self,appname=None,appversion=None,arch=None,description=None,generate=None,permission=None,contact=None,publisher=None,parallel=False,dependence=None,apptag=None,applayer=None,lmgtype=None):
        self.appname = appname
        self.appversion = appversion
        self.arch = arch
        self.description = description
        self.permission = permission
        self.contact = contact
        self.publisher = publisher
        self.generate = generate
        self.parallel = parallel
        # 制作依赖的lmg包
        self.dependence = dependence
        # 制作依赖的系统环境及版本，最好可以从dependence提取
#        self.base = base
        # 容器名+ version + base
        self.apptag = apptag
        self.applayer = applayer
        self.lmgtype = lmgtype
    def keys(self):
        return ('appname','appversion','arch','description','permission','contact','publisher','generate','parallel',"dependence","apptag","applayer","lmgtype")
    def __getitem__(self, item):
        return getattr(self, item)
    def save_meta(self,path):
        metadict = dict(self)
        with open(path, 'w',encoding='utf-8') as f:
            yaml.dump(metadict, f,allow_unicode=True)
    def parse_meta(self,meta,key):
        return meta[key]
    def set_meta(self,key,value):
        if key == "appname":
            self.appname = value
        elif key == "appversion":
            self.appversion = value
        elif key == "arch":
            self.arch = value
        elif key == "description":
            self.description = value
        elif key == "permission":
            self.permission = value
        elif key == "contact":
            self.contact = value
        elif key == "publisher":
            self.publisher = value
        elif key == "generate":
            self.generate = value
        elif key == "parallel":
            self.parallel = value
        elif key == "dependence":
            self.dependence = value
        elif key == "apptag":
            self.apptag = value
        elif key == "applayer":
            self.applayer = value
        elif key == "lmgtype":
            self.lmgtype = value

    def get_stream_from_yaml(self,path):
        with open(path,'r') as f:
            stream = yaml.safe_load(f)
        return stream
    def load_normal_info_from_stream(self,stream):
        self.contact = self.parse_meta(stream,"contact")
        self.generate = self.parse_meta(stream,"generate")
        self.permission = self.parse_meta(stream,"permission")
        self.parallel = self.parse_meta(stream,"parallel")
        self.publisher = self.parse_meta(stream,"publisher")

    def load_meta_from_stream(self,stream):
        self.load_normal_info_from_stream(stream)
        self.appname = self.parse_meta(stream,"appname")
        self.appversion = self.parse_meta(stream,"appversion")
        self.arch = self.parse_meta(stream,"arch")
        self.description = self.parse_meta(stream,"description")
        self.dependence = self.parse_meta(stream,"dependence")
    def print_meta(self):
        metadict= dict(self)
        for key,value in metadict.items():
            print(key,":",value)

#if __name__ == "__main__":
#    lmgmeta = LMGMeta()
#    stream=lmgmeta.get_stream_from_yaml("template/test.yml")
#    lmgmeta.load_normal_info_from_stream(stream)
#    lmgmeta.set_meta("appname","vlc")
#    lmgmeta.set_meta("appversion","1.0")
#    lmgmeta.save_meta("test/test.yml")
#    lmgmeta.print_meta()
