#!/bin/pyton3
import subprocess
import platform
import os
import time
import sys
import requests
import shutil
from tqdm import tqdm
from lmgbuild.lmgexceptions import *
from lmgbuild.lmgpreseter import *
import lmgbuild.logs as logs

DEBUG=0
def runshell(cmd=None,capture_output=True,check=False,shell=False,universal_newlines=True,env=None):
    #    pcst=subprocess.run(["ls"],capture_output,check,shell,universal_newlines)
    pcst=subprocess.run(cmd,capture_output=capture_output,check=check,shell=shell,universal_newlines=universal_newlines,env=env)
    try:
        pcst.check_returncode()
    except subprocess.CalledProcessError:
        logs.debug("Warnning: ----\nCommand %s failed.\nretcode: %s\nstdout: %s\nstderr: %sPlease Check......\n----" % (cmd,pcst.returncode,pcst.stdout,pcst.stderr))
    finally:
        return pcst
def runshellbar(cmd=None,shell=False,stdout=subprocess.PIPE,stderr=subprocess.STDOUT,env=None):
    logs.debug(cmd)
    p = subprocess.Popen(cmd,shell=shell,stdout=stdout,stderr=stderr,env=env)
    count = 0
    while p.poll() is None:
        count+=1
        sys.stdout.write("#")
        sys.stdout.flush()
        time.sleep(1)
        if count > 40:
            sys.stdout.write('\r' + '\033[K')
            count=0
    if p.returncode != 0:
        logs.debug("Warnning: ----\nCommand %s failed.\nretcode: %s\nstdout: %s\nstderr: %sPlease Check......\n----" % (cmd,p.returncode,p.stdout,p.stderr))
    sys.stdout.write("#\n")
    return p
def getarch():
    arch = platform.machine()
#    if arch == "loongarch64":
#        arch = "loong64"
    return arch
def formatpathlist(*path):
    pathlist=list()
    for pathline in path:
        nwpath=pathline.strip()
        if os.path.isfile(nwpath):
            ftpath=os.path.abspath(nwpath)
        else:
            ftpath=nwpath
        pathlist.append(ftpath)
    return pathlist
def formatpath(inpath):
    nwpath=inpath.strip()
    if os.path.exists(nwpath):
        ftpath=os.path.abspath(nwpath)
    else:
        ftpath=nwpath
    return ftpath
def checkdependence(baseruntime):
    imagename = baseruntime + ":" +"brl"
#    cmd = ["docker","inspect",imagename]
    cmd = ["loongker","inspect",imagename]
    ret = runshell(cmd)
    return ret.returncode
def checkimage(imagename):
#    cmd = ["docker","inspect",imagename]
    cmd = ["loongker","inspect",imagename]
    ret = runshell(cmd)
    return ret.returncode
def getdependence(baseruntime,arch):
    # 后续加入配置
    # sync源，检查base是否存在配置中，如存在就下载
    # 在factroy中进行了，此处不需要
#    sync_repository()
    lmghome = os.environ.get("LMGHOME")
    with open(lmghome + "/" + "conf/repository-base.yaml","r") as f:
        stream = yaml.safe_load(f)
        if stream and baseruntime in stream[arch]:
            url = "http://lcf.loongnix.cn/os/lmg/baseimage/" + arch + "/"
            tarname = baseruntime +"_brl.tar"
            downloadurl = url + tarname
            downloadfile(downloadurl,tarname)
            return 0
        else:
            return -1
def installdependence(baseruntime):
    tarname = baseruntime + "_brl.tar"
#    cmd = ["docker","load","-i",tarname]
    cmd = ["loongker","load","-i",tarname]
    ret = runshellbar(cmd)
    return ret.returncode
def auto_installbase(lmgbase,arch):
    ret = checkdependence(lmgbase)
    if ret:
        ret3 = getdependence(lmgbase,arch)
        if ret3 == 0:
            ret4 = import_baseruntime(lmgbase +"_brl.tar")
            if ret4 != 0:
                raise DependInstallError("install baseruntime error")
        elif ret3 == -1:
            raise DownloadBaseError("no baseruntime %s in repository,please use \"lmgbuild -i/--import [baseruntime]\" import the baseruntime" % lmgbase)
        else:
            raise DownloadBaseError("Download baseruntime error")
#    else:
#        print("no baseruntime,please install ....")
#        raise DependError("%s is not exists" % lmgbase)
def check_base_tar(filename):
     if re.match('.*(?=brl.tar$)',filename):
         return 0
     else:
         return -1
def import_baseruntime(baseruntime):
    if not os.path.exists(baseruntime):
        raise BaseRuntimeError(baseruntime + " is not a file")
    if check_base_tar(baseruntime):
        raise BaseRuntimeError("this file is not a baseruntime package")
    imagename = os.path.basename(baseruntime).replace("_brl.tar",":brl")
#    cmd = ["docker","inspect",imagename]
    cmd = ["loongker","inspect",imagename]
    ret=runshell(cmd)
    if ret.returncode:
        logs.message("install baseruntime,please wait ......")
#        cmd = ['docker','load','-i',baseruntime]
        cmd = ['loongker','load','-i',baseruntime]
#        ret=runshellbar(cmd)
        ret=runshellbar(cmd)
        if ret.returncode != 0:
            raise ImageLoadError("%s load failed" % baseruntime)
        else:
            logs.message("install baseruntime complete !!!")
    else:
        logs.warn("baseruntime already installed")
    # 增加工作目录的配置文件，比如隐藏文件，读取环境变量,增加环境变量指定目录
    lmghome = os.environ.get("LMGHOME")
    with open(lmghome + "/" + "conf/local-base.yaml","r+") as f:
        stream = yaml.safe_load(f)
        if stream is None:
            stream = {}
        f.seek(0)
        item = os.path.basename(baseruntime).replace("_brl.tar","")
        arch = platform.machine()
#        if arch == "loongarch64":
#            arch = "loong64"
        if item not in stream.setdefault(arch,[]):
            stream[arch].append(item)
            yaml.dump(stream,f,allow_unicode=True)
    return 0
def downloadfile(url: str, fname: str,tryexec=False):
    fcache = fname +".cache"
    try:
        resp = requests.get(url, stream=True,timeout=10)
        resp.raise_for_status()
        total = int(resp.headers.get('content-length', 0))
        with open(fcache, 'wb') as file, tqdm(
            desc='Downloading ' + fcache,
            total=total,
            unit='iB',
            ascii=True,
            unit_scale=True,
            unit_divisor=1024,
        ) as bar:
            for data in resp.iter_content(chunk_size=1024):
                size = file.write(data)
                bar.update(size)
#    except requests.exceptions.HTTPError as e:
    except Exception as e:
        if tryexec:
            return -1
        else:
            raise(e)
            return -1
    shutil.move(fcache,fname)
    return 0
        #print(e)
def sync_repository(tryexec=True):
    #获取lmghome
    lmghome = os.environ.get("LMGHOME")
    if lmghome and os.path.exists(lmghome):
        confile = os.path.join(lmghome,"conf/repository-base.yaml")
    else:
        confile = os.path.join(os.environ.get("HOME"),".config/lmgbuild/conf/repository-base.yaml")
    #备份配置
    if os.path.isfile(confile):
        shutil.copy(confile,confile + ".bak")
    else:
        os.mknod(confile)
    #获取源位置,fix：configget
    url = "http://lcf.loongnix.cn/os/lmg/"
    repoconfig = url + "repository-base.yaml"
    logs.message("Sync repository......")
    ret=downloadfile(repoconfig,confile,tryexec)
    if ret == 0 :
        logs.message("Complete sync repository !!!")
    else:
        logs.warn("Failed sync repository !!!")
def generate_conf(workdir):
    #conf/default-base.yaml  local-base.yaml  repository-base.yaml
    confdir = workdir + "/conf"
    if not os.path.exists(confdir):
        os.makedirs(confdir)
    conflist = ["default-base.yaml","local-base.yaml","repository-base.yaml"]
    for f in conflist:
        if not os.path.exists(confdir + "/" + f):
            os.mknod(confdir + "/" + f)
    envfile = workdir + "/.env.yaml"
    if os.path.exists(envfile):
            shutil.move(envfile,workdir + "/.env.yaml" + "-" + time.strftime("%Y-%m-%d"))
    with open(workdir + "/.env.yaml","w+",encoding='utf-8') as f:
        stream = dict()
        stream['LMGHOME'] = workdir
        yaml.dump(stream,f,allow_unicode=True)
def generate_cache(workdir):
    #template/cache.yaml
    cachedir = workdir + "/template"
    cachefile = cachedir + "/cache.yaml"
    if not os.path.exists(cachedir):
        os.makedirs(cachedir)
    cache=dict()
    cache['contact'] = {"bugreport": "www.lmg-bug.com", "email": "lmg@loongson.cn"}
    cache['generate'] = {"genfrom":"manual","tool":{"name":"lmgbuild","version":'1.0'}}
    cache['parallel'] = True
    cache['permission'] = "X11 Sound IM-input Dbus Camera Cups Xdg"
    cache['publisher'] = {"email":"lmg@loongson.cn","name":"lmg"}
    with open(cachefile,"w") as f:
        yaml.dump(cache,f,allow_unicode=True)
def showorkspace():
    lmghome = os.environ.get("LMGHOME")
    print(lmghome)
def getruntimeconfs():
    lmghome = os.environ.get("LMGHOME")
    runtimeconfs = ["conf/default-base.yaml","conf/local-base.yaml"]
    runtimeconfs = list(map(lambda x:lmghome + "/" +x ,runtimeconfs))
    return runtimeconfs
def getruntime():
    runtimeconfs = getruntimeconfs()
    supportarch = []
    runtime_dic = {}
    for path in runtimeconfs:
        with open(path,'r') as f:
            stream = yaml.safe_load(f)
            if stream is None:
                continue
            supportarch += list(stream.keys())
            supportarch = list(dict.fromkeys(supportarch))
            for arch in supportarch:
                for item in stream.setdefault(arch,[]):
                    if item not in runtime_dic.setdefault(arch,[]):
                       runtime_dic.setdefault(arch,[]).append(item)
    return runtime_dic
def showruntime():
    runtime_dic = getruntime()
    print(runtime_dic)
def deleteruntime(druntime):
    runtime_dic = getruntime()
    arch = getarch()
    if druntime in runtime_dic.setdefault(arch,[]):
        print(druntime)
#        cmd = ["docker","rmi",druntime + ":brl","-f"]
        cmd = ["loongker","rmi",druntime + ":brl","-f"]
        ret=runshell(cmd)
        if ret.returncode == 0:
            runtimeconfs = getruntimeconfs()
            for path in runtimeconfs:
                with open(path,'w+') as f:
                    stream = yaml.safe_load(f)
                    if stream is None:
                        continue
                    for arch in list(stream.keys()):
                        if druntime in stream[arch]:
                            stream[arch].remove(druntime)
                            yaml.dump(stream,f,allow_unicode=True)
        else:
            print(ret)
        #docker rmi druntime
        #config file rmi druntime
    else:
        print("no baseruntime %s" % druntime)
#def try_sync_repostory():
#    lmghome = os.environ.get("LMGHOME")
#    if lmghome and os.path.exists(lmghome):
#        confile = os.path.join(lmghome,"conf/repository-base.yaml")
#    else:
#        confile = os.path.join(os.environ.get("HOME"),".config/lmgbuild/conf/repository-base.yaml")
#    #备份配置
#    shutil.copy(confile,confile + ".bak")
#    #获取源位置,fix：configget
#    repoconfig = url + "repository-base.yaml"
#    print("Sync repository......")

    #获取base配置
    #下载repositrory
    #替换repositrory的文件



