# -*- encoding: utf-8 -*-

from contextlib import contextmanager
from datetime import datetime
import sys
import os
from traceback import format_exception
import colorama
import time
from lmgbuild.conf import settings
#DEBUG=os.environ.get("LMGDEBUG")

def color(color_):
    """Utility for ability to disabling colored output."""
    return color_
#    if settings.no_colors:
#        return ''
#    else:
#        return color_


def warn(title):
    sys.stderr.write(u'{warn}[WARN] {title}{reset}\n'.format(
        warn=color(colorama.Back.RED + colorama.Fore.WHITE
                   + colorama.Style.BRIGHT),
        reset=color(colorama.Style.RESET_ALL),
        title=title))
def message(title):
    sys.stderr.write(u'{msg}[Message] {title}{reset}\n'.format(
        msg=color(colorama.Back.GREEN + colorama.Fore.WHITE
                   + colorama.Style.BRIGHT),
        reset=color(colorama.Style.RESET_ALL),
        title=title))
def exception(title, exc_info):
    sys.stderr.write(
        u'\n{warn}[Exception] {title}:{reset}\n{trace}'
        u'{warn}----------------------------{reset}\n\n'.format(
            warn=color(colorama.Back.RED + colorama.Fore.WHITE
                       + colorama.Style.BRIGHT),
            reset=color(colorama.Style.RESET_ALL),
            title=title,
            trace=''.join(format_exception(*exc_info))))

def rule_failed(rule, exc_info):
    exception(u'Rule {}'.format(rule.name), exc_info)


def failed(msg):
    sys.stderr.write(u'{red}{msg}{reset}\n'.format(
        msg=msg,
        red=color(colorama.Fore.RED),
        reset=color(colorama.Style.RESET_ALL)))

def debug(msg):
    if settings.debug:
        sys.stderr.write(u'\n{blue}{bold}DEBUG:{reset} {msg}\n'.format(
        msg=msg,
        reset=color(colorama.Style.RESET_ALL),
        blue=color(colorama.Fore.BLUE),
        bold=color(colorama.Style.BRIGHT)))


@contextmanager
def debug_time(msg):
    started = datetime.now()
    try:
        yield
    finally:
        debug(u'{} took: {}'.format(msg, datetime.now() - started))

#try:
#    raise(Exception)
#except Exception:
#    exception("exception asdasd",sys.exc_info())
#failed("failed------")
#warn("waasdasdasdsarn-----")
#debug("debug asdassdasd")
