#!/bin/python
#pip3 install python-gnupg

import gnupg as gp
import os
from pathlib import Path

class lmg_gpg(object):
    def __init__(self,gnupghome):
        """init the lmg_gpg"""
        self.gnupghome=gnupghome
        self.gnupgrevocs=gnupghome + "/" + "openpgp-revocs.d"
        self.gnupgprivate=gnupghome +"/" + "private-keys-v1.d"
        # asc secret key
        self.lmg_seckeyid=[]
        self.lmg_pubkeyid=[]
#        self.mklmgpgp_dir()
        self.gnupg=gp.GPG(gnupghome=gnupghome)

    def mklmgpgp_dir(self):
        """make the basedir"""
        if not os.path.exists(self.gnupghome):
            os.mkdir(self.gnupghome,0o700)
            os.mkdir(self.gnupgrevocs,0o700)
            os.mkdir(self.gnupgprivate,0o700)

    def import_lmg_key(self,keypath,keytype="public"):
        """key type : 1. public 2. secret """
        if os.path.exists(keypath):
            f=open(keypath)
            key_data=f.read()
            import_result=self.gnupg.import_keys(key_data)
            if keytype is "public":
                self.lmg_pubkeyid.append(import_result.fingerprints[0])
            elif keytype is "secret":
                self.lmg_seckeyid.append(import_result.fingerprints[0])
            f.close()

    def lmg_sign(self,keyid,filepath,outputdir=None):
        """use keyid sign file"""
        if outputdir is None:
            outputdir = os.path.dirname(filepath)
        stream=open(filepath,"rb")
        signed = self.gnupg.sign_file(stream,keyid=keyid,detach = True, output=outputdir+"/" + os.path.basename(filepath) + ".sig")
        if signed.status == "signature created":
            print("signed sucesses")
            return 0
        else:
            print("signed error")
            return -1
    def lmg_verify_sign(self,sigfile,datafile):
        """check the sign use allkey"""
        stream=open(sigfile,"rb")
        verified=self.gnupg.verify_file(stream,datafile)
        if verified.valid:
            print(verified.status)
            return 0
        else:
            print(verified.status)
            return -1

if __name__ == "__main__":
    pass
    test_lmg = lmg_gpg("/home/loongson/test")
    test_lmg.import_lmg_key("/home/loongson/secret-key-lmg.asc","secret")
    test_lmg.import_lmg_key("/home/loongson/public-key-lmg.asc")
    for key in test_lmg.lmg_seckeyid:
        print("sec:")
        print(key)
    for key1 in test_lmg.lmg_pubkeyid:
        print("pub:")
        print(key1)
    test_lmg.lmg_sign(test_lmg.lmg_seckeyid[0],"/home/loongson/a")
    test_lmg.lmg_verify_sign("/home/loongson/a.sig","/home/loongson/a")
