#!/bin/bash
# This script will uninstall lmgsuits.
#set -x
function lmgutils_uninstall()
{
    toolspath="/usr/local/lmg/bin/"

    if [ -d "$toolspath" ]; then
	rm -rf $toolspath
    fi

}
function lmg_binary_uninstall()
{
	libpath="/var/lib/lpkg/"
	lpkgpath="/usr/local/bin/"
	if [ -d "$libpath" ]; then
		rm -rf $libpath
	fi
	if [ -d "$lpkgpath"  ]; then
		rm -rf $lpkgpath
	fi
}
function mime_config_delete()
{
    mimepath="/usr/share/mime/"
    mime_config_path=$mimepath"packages/lcf-package.xml"
    iconspath="/usr/share/icons/hicolor/"	
    mime_icon_path=$iconspath"scalable/mimetypes/lmgpackage.png"
    apps="/usr/share/applications/"
    desktoppath=$apps"lcf-installer.desktop"
    if [ -f "$mime_config_path" ]; then
	    rm -f $mime_config_path
    fi
    if [ -f "$mime_icon_path" ]; then
	    rm -f $mime_icon_path
    fi
    gtk-update-icon-cache  $iconspath
    update-mime-database  $mimepath
    sed -i "/lcf-installer.desktop/d" $apps"mimeapps.list"
    if [ -f "$desktoppath" ]; then
	    rm -f $desktoppath
    fi
}

function delete_log()
{
	users=` who -q | head -n 1 `
	OLD_IFS="$IFS"
	IFS=" "
	Users=($users)
	IFS="$OLD_IFS"
	for CurUser in ${Users[@]} 
	do
		logpath="/home/"$CurUser"/.lmg"
		if [ -d "$logpath" ]; then
			rm -rf $logpath
		fi
	done
}

function lmg_suit_uninstall()
{
    mime_config_delete
    lmgutils_uninstall
    lmg_binary_uninstall
    delete_log
}

lmg_suit_uninstall
echo "lmg suit uninstallation is complete"
