#!/bin/sh
# This script will install lmgbuild, lmgmanager, lmgrun.
#set -x
function docker_group_check()
{
    user=`getent passwd \`who\` | head -n 1 | cut -d : -f 1`
    while read gline
    do
        groupname=`echo $gline | awk -F":" '{print $1}'`
        #groupidgrp=`echo $gline | awk -F":" '{print $3}'`
        hasdockergroup=0

        if [ "$groupname" = "docker" ]; then
            hasdockergroup=1
            result=$(echo $gline | grep ":$user")
            if [[ "$result" != "" ]]; then
                echo "$groupname:$user"
            else
                gpasswd -a $user docker
                systemctl restart docker
                chmod a+rw /var/run/docker.sock
            fi
            return
        fi
    done < /etc/group

    if [ $hasdockergroup -eq 0 ]; then
        echo "docker isn't in the group"
    fi
}
function lmgutils_install()
{
    toolspath="/usr/local/lmg/bin/"
    #static zstd bin
    zstdfile=$toolspath"zstd"
    #static tar bin
    tarfile=$toolspath"tar"

    if [ ! -d "$toolspath" ]; then
         mkdir -p "$toolspath"
    fi

    cp ./lmgutils/* $toolspath  -rf
}
function lmgmanager_install()
{
    mkdir -p /var/lib/lpkg/info
    mkdir -p /usr/share/icons/lmg
    touch /var/lib/lpkg/status
    touch /var/lib/lpkg/appindex.cfg
    cp ./lpkg /usr/local/bin/
}
function lmgrun_install()
{
    cp ./lmgrun /usr/local/bin/
}

function lmgbuild_install()
{
    cp ./lmgbuild /usr/local/bin/
}

function lmg_suit_destroy()
{
    rm ../lmg_suit_* -rf
}
function lmg_suit_install()
{
    binpath="/usr/local/bin/"
    if [ ! -d "$binpath" ]; then
         mkdir -p "$binpath"
    fi

    lmgutils_install
    lmgbuild_install
    lmgmanager_install
    lmgrun_install
    #lmg_suit_destroy
}
#docker_group_check
lmg_suit_install
echo "lmg suit installation is complete"
