#!/usr/bin/python3
# -*- coding: utf-8 -*-
# @Desc: { 项目枚举类模块 }

from enum import Enum

class StatusCodeEnum(Enum):
    """状态码枚举类"""

    OK = (0, '成功')
    ERROR = (-1, '错误')

    APP_CONTAINER_RUNNING        = (10, '应用所属容器正在运行')
    APP_CONTAINER_DNE            = (11, '应用所属容器无状态')
    APP_CONTAINER_COR_EXIT       = (12, '应用所属容器正确退出')
    APP_CONTAINER_MIS_EXIT       = (13, '应用所属容器错误退出')

    CHECK_RUN_DOCKER_ERR         = (100, 'loongker命令不存在')
    CHECK_IMAGE_CMD_ERR          = (101, '检测镜像是否存在命令执行错误')
    CHECK_CONTAINER_CMD_ERR      = (102, '检测容器是否存在命令执行错误')

    APP_CONTAINER_INFO_ERR       = (200, '获取应用所属容器信息失败')
    APP_COLD_START_ERR           = (201, '应用冷启动失败')
    APP_HOST_START_ERR           = (202, '应用热启动失败')
    APP_PARALLEL_START_ERR       = (203, '应用多开错误')

    IMAGE_ERR                    = (300, '应用所需镜像不存在')
    CONTAINER_RM_ERR             = (301, '应用所属容器删除错误')

    @property
    def code(self):
        """获取状态码"""
        return self.value[0]

    @property
    def errmsg(self):
        """获取状态码信息"""
        return self.value[1]

if __name__ == '__main__':
    code = StatusCodeEnum.OK.code
    errmsg = StatusCodeEnum.OK.errmsg
    print("code:%s errmsg:%s" %(code, errmsg))

