#!/usr/bin/python3
# -*- coding: utf-8 -*-
# @Desc: { 项目邮件模块 }

import os
import logging
from smtplib import SMTP_SSL
from email.mime.text import MIMEText
from email.utils import parseaddr, formataddr
from email.mime.multipart import MIMEMultipart

from lmgrun.baseinfo import BaseInfo

log = logging.getLogger(__name__)

def _format_addr(s):
    addr = parseaddr(s)
    return formataddr(addr)

def sendMail(files: list):
    message = 'lmg bugreport 邮件...'
    Subject = 'Bug report'
    # 显示发送人
    sender_show = 'lmg'
    # 显示收件人
    recipient_show = 'sangmeng'
    # 抄送人
    cc_show = ''
    # 实际发给的收件人
    #TODO:
    #use contact email
    #BaseInfo.cemail
    to_addrs = 'isangmeng@163.com'
    # 填写真实的发邮件服务器用户名、密码
    user = 'imacos@yeah.net'
    password = 'QIMBRPHCIRJKFKYS'
    # 邮件内容
    msg = MIMEMultipart()

    msg.attach(MIMEText(message, 'plain', _charset="utf-8"))
    for f in files:
        filename = os.path.split(f)[1]
        att = MIMEText(open(f, 'rb').read(), 'base64', 'utf-8')
        att["Content-Type"] = 'application/octet-stream'
        att.add_header("Content-Disposition", "attachment", filename=("gbk", "", filename))
        msg.attach(att)
    # 邮件主题描述
    msg["Subject"] = Subject
    msg['From'] = _format_addr(u'%s <%s>' % (sender_show, user))
    msg["To"] = _format_addr(to_addrs)
    msg["Cc"] = cc_show
    with SMTP_SSL(host="smtp.yeah.net",port=465) as smtp:
        # 登录发邮件服务器
        smtp.login(user = user, password = password)
        # 实际发送、接收邮件配置
        try:
            smtp.sendmail(from_addr = user, to_addrs=to_addrs.split(','), msg=msg.as_string())
            log.debug("Bug report success.")
        except Exception as e :
            log.error("sendmail failed:%s", str(e))
