import attr

@attr.s
class Appinfo(object):
    """
    App info from yaml.
    eg:appname, appversion, command...
    """
    command        = attr.ib(default=None)
    yamlfile       = attr.ib(default=None)
    image          = attr.ib(default=None)
    name           = attr.ib(default=None)
    version        = attr.ib(default=None)
    uid            = attr.ib(default=None)
    home           = attr.ib(default=None)
    type           = attr.ib(default="normal")
    permission     = attr.ib(default=attr.Factory(list))
    environment    = attr.ib(default=attr.Factory(dict))

    def get_container_name(self):
        """
        Get the name for the app's container.
        """
        if self.name is None:
            #FXIME: It should be wrong when there is no name
            return self.name
        else:
            return "{}_{}".format(self.name, self.version)

    def get_image_name(self):
        """
        Get the name of the image to be used.
        """
        if self.name is None:
            #FXIME: It should be wrong when there is no name
            return self.name
        else:
            return "{}:{}".format(self.name, self.version)
