#!/bin/bash

cd $(dirname "$0")
cd .. 

export HOME=/root
export GOPATH=$(pwd)/
PREFIX=$(pwd)/build
VERSION=$(cat VERSION)


PACKAGE=${PACKAGE:-containerd.io}
GO_SRC_PATH=$(pwd)/src/github.com/containerd/containerd
GO_RUNC_SRC_PATH=$(pwd)/src/github.com/opencontainers/runc

REF="6fbe2f9a8e085ffeb72c00027c4f9c889261602c"

set -x; make -C $GO_SRC_PATH --no-print-directory \
	DESTDIR=$(pwd) \
	VERSION=$VERSION \
	REVISION=$REF \
	PACKAGE=$PACKAGE \
	static-binaries


set -x; make -C $GO_RUNC_SRC_PATH  --no-print-directory \
	BINDIR="$(pwd)/bin" \
	BUILDTAGS='seccomp apparmor selinux' \
	static

mkdir -p static-build/static-bin/containerd.io/usr/bin

install -D -m 0755 $GO_SRC_PATH/static-bin/* static-build/static-bin/containerd.io/usr/bin
install -D -m 0755 $GO_RUNC_SRC_PATH/runc static-build/static-bin/containerd.io/usr/bin
install -D -m 0644 common/containerd.service static-build/static-bin/containerd.io/lib/systemd/system/containerd.service
install -D -m 0644 common/containerd.toml    static-build/static-bin/containerd.io/etc/containerd/config.toml
install -D -m 0755 static-compile/static_install.sh       static-build/static-bin/install.sh
install -D -m 0755 static-compile/static_uninstall.sh     static-build/static-bin/uninstall.sh
cd static-build

tar czvf containerd-static-bin.tar.gz static-bin 
