#!/bin/bash



cd $(dirname "$0")
cd ..
VERSION=$(cat VERSION)
export HOME=/root
export GOPATH=$(pwd)/go
PREFIX="$(pwd)/build"

mkdir -p $(pwd)/build
mkdir -p $(pwd)/go/src/github.com/docker
ln -snf $(pwd)/sources/engine $(pwd)/go/src/github.com/docker/docker
ln -snf $(pwd)/sources/cli $(pwd)/go/src/github.com/docker/cli
# Build the daemon and dependencies


cd sources/engine && VERSION=$VERSION PRODUCT=docker ./hack/make.sh binary

cd - 
PREFIX=$PREFIX TMP_GOPATH="$(pwd)/go" installer/install.sh tini
PREFIX=$PREFIX TMP_GOPATH="$(pwd)/go" installer/install.sh proxy
# Build the CLI
cd $(pwd)/go/src/github.com/docker/cli && \
	LDFLAGS='' DISABLE_WARN_OUTSIDE_CONTAINER=1 make VERSION=$VERSION GITCOMMIT=$CLI_GITCOMMIT binary 
# Make sure to set LDFLAGS="" since, dpkg-buildflags sets it to some weird values

cd -
set -e; LDFLAGS='' bash installer/plugins/buildx.installer build 

set -x
# docker-ce-cli install
install -D -m 0755 $(pwd)/go/src/github.com/docker/cli/build/docker static-build/static-bin/docker-ce-cli/usr/bin/docker
# docker-ce install
install -D -m 0644 $(pwd)/sources/docker.service static-build/static-bin/docker-ce/lib/systemd/system/docker.service
install -D -m 0644 $(pwd)/sources/docker.socket static-build/static-bin/docker-ce/lib/systemd/system/docker.socket
install -D -m 0644 $(pwd)/sources/daemon.json static-build/static-bin/docker-ce/etc/docker/daemon.json
install -D -m 0755 $(readlink -e sources/engine/bundles/binary-daemon/dockerd) static-build/static-bin/docker-ce/usr/bin/dockerd
install -D -m 0755 $PREFIX/docker-proxy static-build/static-bin/docker-ce/usr/bin/docker-proxy
install -D -m 0755 $PREFIX/docker-init static-build/static-bin/docker-ce/usr/bin/docker-init
install -D -m 0755 $(pwd)/static-compile/static_install.sh static-build/static-bin/install.sh
install -D -m 0755 $(pwd)/static-compile/static_uninstall.sh static-build/static-bin/uninstall.sh

cd static-build
tar czvf $(pwd)/static-bin.tar.gz static-bin
