import xml.etree.ElementTree as ET

def get_menu_file():
    return '/etc/xdg/menus/applications-merged/lmg.menu'

def get_directory_file():
    return '/usr/share/desktop-directories/lmg.directory'

def create_menu(deskfilename):
    root = ET.Element('Menu')
    Name = ET.SubElement(root, 'Name')
    Name.text = 'Applications'
    Menu = ET.SubElement(root, 'Menu')
    ItemName = ET.SubElement(Menu, 'Name')
    ItemName.text = 'lmg'
    Directory = ET.SubElement(Menu, 'Directory')
    Directory.text = 'lmg.directory'
    Include = ET.SubElement(Menu, 'Include')
    Filename = ET.SubElement(Include, 'Filename')
    Filename.text = deskfilename
    tree = ET.ElementTree(root)
    tree.write(get_menu_file())

def create_desktop_directory_file():
    line = ['[Desktop Entry]\n']
    line.append('Type=Directory\n')
    line.append('Name=Lmg\n')
    line.append('Icon=wps-office-kingsoft\n')

    with open(get_directory_file(), 'w') as f:
        for linewise in line:
            f.write(linewise)

def add_tag(flag, tag, text):
    tree = ET.parse(get_menu_file())
    root = tree.getroot()
    newEle = ET.Element(tag)
    newEle.text = text

    sub = root.find(flag)
    sub.append(newEle)
    tree.write(get_menu_file())

def rm_tag(flag, tag, text):
    tree = ET.parse(get_menu_file())
    root = tree.getroot()
    sub = root.find(flag)

    for child in root.iter(tag):
        if child.text == text:
            sub.remove(child)
            break

    tree.write(get_menu_file())

def menu_init(deskfilename):
    create_menu(deskfilename)
    create_desktop_directory_file()

def menu_add_desk(deskfilename):
    add_tag('Menu/Include', 'Filename', deskfilename)

def menu_rm_desk(deskfilename):
    rm_tag('Menu/Include', 'Filename', deskfilename)

if __name__ == '__main__':
    #menu_init('weixin.desktop')
    menu_add_desk('weixin.desktop')
    #menu_add_desk('lbrowser.desktop')
    #menu_rm_desk('lbrowser.desktop')
   # menu_rm_desk('weixin.desktop')
    
