import os
import sys
import subprocess
from ..utils.execute import execute
from ..utils.exceptions import RuncmdError

def inst_zstd():
    runcmd = ['sudo', 'apt', 'install', 'zstd']
    result = execute(runcmd)
    if not result.succeeded:
        raise RuncmdError('install zstd failed.')

def create_database_dir():
    runcmd = ['sudo', 'mkdir', '-p', '/var/lib/lpkg/info']
    result = execute(runcmd)
    if not result.succeeded:
        raise RuncmdError('create database dir failded')

def create_database_file():
    runcmd = ['sudo', 'touch', '/var/lib/lpkg/status']
    result = execute(runcmd)
    if not result.succeeded:
        raise RuncmdError('create database file failded')

def create_icon_dir():
    runcmd = ['sudo', 'mkdir', '-p', '/usr/share/icons/lmg']
    result = execute(runcmd)
    if not result.succeeded:
        raise RuncmdError('create icon dir failded')

def group_add():
    user=os.getlogin()
    runcmd = ['gpasswd', '-a', user,  'docker']
    result = execute(runcmd)
    if not result.succeeded:
        raise RuncmdError("add to docker group failed")

def restart_docker():
    runcmd = ['systemctl', 'restart',  'docker']
    result = execute(runcmd)
    if not result.succeeded:
        raise RuncmdError("restart docker failed")

def chmod_docker_sock():
    runcmd = ['chmod', 'a+rw', '/var/run/docker.sock']
    result = execute(runcmd)
    if not result.succeeded:
        raise RuncmdError("chmod docker.sock failed")

if __name__=='__main__':
    inst_zstd()
    create_database_dir()
    create_database_file()
    create_icon_dir()
    group_add()
    restart_docker()
    chmod_docker_sock()

